package com.test;

import org.infinispan.cdi.Infinispan;
import org.infinispan.cdi.OverrideDefault;
import org.infinispan.config.Configuration;
import org.infinispan.config.GlobalConfiguration;
import org.infinispan.manager.DefaultCacheManager;
import org.infinispan.manager.EmbeddedCacheManager;

import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.inject.Produces;


/**
 * @author Kevin Pollet
 */
public class Config {

   @Clustered
   @Infinispan("clustered")
   @Produces
   public Configuration clusteredConfiguration;

   @Produces
   @ApplicationScoped
   @OverrideDefault
   public EmbeddedCacheManager defaultCacheManager() {

      return new DefaultCacheManager(
            GlobalConfiguration.getClusteredDefault().fluent()
            .transport().clusterName("shared-cache-cluster").addProperty("configurationFile", "jgroups-tcp.xml")
            .build() ,

            new Configuration().fluent()
            .clustering().mode(Configuration.CacheMode.REPL_ASYNC)
            .build()
      );
   }
}
